<?php
/*
* Copyright (C) 2008 Soft Ventures, Inc. All rights reserved.
*/

/* Initialize Joomla framework */
define( '_JEXEC', 1 );


$path = dirname(__FILE__);
$path = str_replace('\\', '/', $path);
$jpath = str_replace('modules/mod_sv_reminders', '', $path);

define('JPATH_BASE', $jpath );

define( 'DS', DIRECTORY_SEPARATOR );

/* Required Files */
require_once ( JPATH_BASE .DS.'includes'.DS.'defines.php' );
require_once ( JPATH_BASE .DS.'includes'.DS.'framework.php' );

/* Create the Application */
$mainframe =& JFactory::getApplication('site');
$err = "";

$database = &JFactory::getDBO(); 
$query = "SELECT params FROM #__modules WHERE module='mod_sv_reminders' and published=1";
$database->setQuery($query);
$raw_params = "";
$raw_params = $database->loadResult();
if ($database -> getErrorNum()) {
	echo $database -> stderr();
}
if($raw_params==""){
	$err = "No published module found.";
}
$params = new JParameter($raw_params);

$username = JRequest::getString( 'user', '' );
$password = JRequest::getString( 'pwd', '' );

/*  cannot pass data to cron, rats
	if($err == ""){
	if($username == "" or $password == ""){
		$err = "Username and/or Password missing.";
	} else if($params->get("username", "") != $username){
		$err = "Incorrect user specified";
	} else {
		// get password field from database for the provided username
		$query = "SELECT * FROM #__users WHERE username='".$username."'";
		$database->setQuery($query);
		$user_info = $database->loadObject();
		$raw_pwd = $user_info->password;
		if($raw_pwd == ""){
			$err = "Invalid Username and/or Password.";
		} else {
			$ary_raw_pwd = split(":",$raw_pwd);
			$salt = $ary_raw_pwd[1];
		
			if($ary_raw_pwd[0] != (md5($password.$salt))){
				$err = "Incorrect Username and/or Password.";
			} else {
				// validated ok
			}			
		}
	}
}
*/

	if($params->get("test_mode", "") == "1"){
		echo "Running in Test Mode. <br/>Don't forget to turn off Test Mode before going into production.<br/>";
	} else {
		if($_SERVER['SERVER_NAME'] != ""){
		  die('This tool can only be executed from cron');
		} 
	}
	
	$days_before = $params->get("days_before", "");
	$component = $params->get("component", "");
	$version = $params->get("version", "");
	if($days_before == ""){ $err .= "No days before specified. <br>";}
	if($component == ""){ $err .= "No component specified. <br>";}
	if($version == ""){ $err .= "No version specified. <br>";}
	if($component != "ABPro" and $component != "RBPro"){ $err .= "Component must be either 'ABPro' or 'RBPro'.";}
	//if($version != "1.3"){ $err .= "Currently only works with ABPro version 1.3 or RBPro version 1.3.";}
 
 	$ary_days_before = split(",", $days_before);
	if(count($ary_days_before) == 0){ $err .= "Unable to interpret days before entry. <br>";}
	foreach($ary_days_before as $days){
		if(!is_numeric($days)){$err .= "Non-numeric value in days before entry. <br>";}
		if(intval($days) < 1){$err .= "Days before must be 1 or greater. <br>";}
		//$err .= $days;
	}

	$language = JFactory::getLanguage();

	// get IDs of accepted bookings that start $days_before now/
	if($component == "ABPro"){
		if($version == "1.3"){
			require_once ( JPATH_BASE .DS.'administrator'.DS.'components'.DS.'com_rsappt_pro13'.DS.'sendmail.php' );
			$language->load('com_rsappt_pro13', JPATH_SITE, null, true);
		} else {
			require_once ( JPATH_BASE .DS.'administrator'.DS.'components'.DS.'com_rsappt_pro14'.DS.'sendmail.php' );
			$language->load('com_rsappt_pro14', JPATH_SITE, null, true);
		}
		$request_table = "#__sv_apptpro_requests";
		$resource_table = "#__sv_apptpro_resources";
		$config_table = "#__sv_apptpro_config";
	} else {
		require_once ( JPATH_BASE .DS.'administrator'.DS.'components'.DS.'com_rsbook_pro13'.DS.'sendmail.php' );
		$language->load('com_bookpro_pro13', JPATH_SITE, null, true);
		$request_table = "#__sv_bookpro_requests";
		$resource_table = "#__sv_bookpro_resources";
		$config_table = "#__sv_bookpro_config";
	}	

	// get config info
	$sql = 'SELECT * FROM '.$config_table;
	$database->setQuery($sql);
	$config = NULL;
	$config = $database -> loadObject();
	if ($database -> getErrorNum()) {
		echo $database -> stderr();
	}
	

if($err != ""){
	echo $err;
} else {

	// need current loacal time based on server time adjusted by Joomla time zone setting
	$config =& JFactory::getConfig();
	$tzoffset = $config->getValue('config.offset');      
	$offsetdate = JFactory::getDate();
	$offsetdate->setOffset($tzoffset);
	$reminder_log_time_format = "%H:%M - %b %d";

	$status = '';
	foreach($ary_days_before as $days){
		
		$sql = "SELECT ".$request_table.".*, DATE_FORMAT(".$request_table.".startdate, '%W %M %e, %Y') as display_startdate, ".
			"DATE_FORMAT(".$request_table.".starttime, ' %l:%i %p') as display_starttime ,".
			$resource_table.".name AS resource_name ".
			"FROM (".$request_table." INNER JOIN ".$resource_table." ".
			" ON  ".$request_table.".resource = ".$resource_table.".id )". 
			" WHERE ".$request_table.".id IN (".
			"  SELECT id FROM ".$request_table." WHERE request_status = 'accepted' ".
			"  AND DATE_ADD(CURDATE(),INTERVAL ".intval($days)." DAY) = startdate)";
		$database->setQuery($sql);
		$requests = NULL;
		$requests = $database -> loadObjectList();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
		}
		//echo $sql."<br/>";	

		if(count($requests) == 0){
			$status .= "No bookings found for ".intval($days)." days out.<br>";
			logReminder($status, -1, -1, "", $offsetdate->toFormat($reminder_log_time_format));
		} else {
			$subject = JText::_('RS1_REMINDER_EMAIL_SUBJECT');
			
			$k = 0;
	
			// dev only
			//ini_set ( "SMTP", "shawmail.cg.shawcable.net" ); 
	
			for($i=0; $i < count( $requests ); $i++) {
				$request = $requests[$i];
				$err = "";
				if($request->email == ""){
					// no email address
					$err .= "No email address, ";
				} else if($request->request_status != "accepted"){
					// is not 'accepted'?
					$err .= "Request status not 'Accepted', ";
				}
				if($err != ""){
					$line = "Recipient: ". $request->email ." - ". $err." *** NO REMINDER SENT *** ";											
					logReminder($line, $request->id, $request->user_id, $request->name, $offsetdate->toFormat($reminder_log_time_format));
					$status .= $line."<br>";
				} else {
					if(sendMail($request->email, $subject, "reminder", $request->id)){					 
						$line = "Recipient: ". $request->email . ", ".stripslashes($request->name). ", ".stripslashes($request->resource_name).", ".$request->display_starttime. ", ".$request->display_startdate." - Ok";											
						logReminder($line, $request->id, $request->user_id, $request->name, $offsetdate->toFormat($reminder_log_time_format));
						$status .= $line."<br>";
					} else {
						$line = "Recipient: ". $request->email . ", ".stripslashes($request->name). ", ".stripslashes($request->resource_name).", ".$request->display_starttime. ", ".$request->display_startdate." - Failed";											
						logReminder($line, $request->id, $request->user_id, $request->name, $offsetdate->toFormat($reminder_log_time_format));
						$status .= $line."<br>";
					}			
					
				}
			}

		}
	}
}

	// dev only
	//ini_set ( "SMTP", "shawmail.cg.shawcable.net" ); 

	// email $status and/or $err to admin
	$mailTO = $params->get("mail_to", "");
	if($mailTO == ""){
		$mailTO = $config->mailTO;
	}
		
	$headers = 'From:'.$config->mailFROM . "\r\n";
	if($config->html_email == "Yes"){
		$message = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">'.
		'<html><style type="text/css">body,td,th,p{font-family:arial;font-size:12px;}</style><body>';
	}
	
	if($err==""){
		$message .= $status;
	} else {
		$message .= $err;
	}	

	if($config->html_email != "Yes"){
		$message = str_replace("<br>", "\r\n", $message);
	} else {
		$message .= "</body></html>";
	}
		
	if($config->html_email == "Yes"){
		$headers .= 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-type: text/html' . "\r\n";
	}	
	
	mail($mailTO, "Reminder cron results", $message, $headers);
	
	echo "Run completed";


	exit;	
	
	
?>